/* ************************************************************************** */
/*                                       _____           _                    */
/*  main.h                              |_   _|__  _   _| |__   ___ _   _     */
/*  | Project : TuQuoque                  | |/ _ \| | | | '_ \ / _ \ | | |    */
/*                                        | | (_) | |_| | | | |  __/ |_| |    */
/*  By: thomas <thomas@touhey.fr>         |_|\___/ \__,_|_| |_|\___|\__, |.fr */
/*  Last updated: 2016/05/26 08:08:29                               |___/     */
/*                                                                            */
/* ************************************************************************** */

#ifndef MAIN_H
# define MAIN_H
# include <main/img.h>
# include <main/maps.h>
# include <main/menus.h>
# include <stdlib.h>

/*
** -----------------------------------------------------------------------------
**	AI
** -----------------------------------------------------------------------------
*/

typedef struct {
	/* ticks before changing weapon state */
	int ticks_before_changing_wps;
} ai_t;

/*
** -----------------------------------------------------------------------------
**	Character
** -----------------------------------------------------------------------------
*/

typedef enum {
	dir_up, dir_right, dir_down, dir_left
} direction_t;

typedef enum {
	wp_hand,
	wp_knife
} weapon_t;

typedef enum {
	wps_hidden,
	wps_trig, /* triggered, "just put on" */
	wps_out
} weapon_status_t;

typedef struct {
	/* lives */
	int life;
	/* "micro" coordinates */
	int x, y;
	/* moving coordinates (vectors) */
	int vx, vy;
	/* calculated moving coordinates after moving */
	int cvx, cvy;
	/* direction */
	direction_t direction;
	/* weapon */
	weapon_t weapon;
	weapon_status_t weapon_status;
	int weapon_step;
	/* stepping */
	int step;
	/* main character image (up, right, down, left) */
	Image *image;
} character_t;

/*
** -----------------------------------------------------------------------------
**	Selected level
** -----------------------------------------------------------------------------
*/

extern map_t *map;
extern map_ai_t *map_ai;

/*
** -----------------------------------------------------------------------------
**	Helpers
** -----------------------------------------------------------------------------
*/

int quit_popup(void);
void sleep_some_time(int value);

#endif /* MAIN_H */
