/* ************************************************************************** */
/*                                       _____           _                    */
/*  main/map.h                          |_   _|__  _   _| |__   ___ _   _     */
/*  | Project : TuQuoque                  | |/ _ \| | | | '_ \ / _ \ | | |    */
/*                                        | | (_) | |_| | | | |  __/ |_| |    */
/*  By: thomas <thomas@touhey.fr>         |_|\___/ \__,_|_| |_|\___|\__, |.fr */
/*  Last updated: 2016/08/09 14:38:22                               |___/     */
/*                                                                            */
/* ************************************************************************** */

#ifndef MAIN_MAP_H
# define MAIN_MAP_H

/**
 *	map_t:
 *	The map format.
 *
 *	This format is loaded from an object file generated from simple map format.
 *	See `MAP.md` for more info about how maps are encoded.
 */

typedef struct {
	/* dimensions */
	uint8_t w, h;
	/* player spawn */
	uint8_t spawn_x, spawn_y;
	/* blocks */
	uint8_t __attribute__((aligned(4))) b[];
} __attribute__((aligned(4))) map_t;

/**
 *	map_ai_spawn_t:
 *	A map enemy spawn raw data (position).
 */

typedef struct {
	/* position */
	uint8_t x, y;
} __attribute__((aligned(2))) map_ai_spawn_t;

/**
 *	map_ai_t:
 *	The map enemies spawn format.
 *
 *	Contains all of the enemies spawn information, like their positions (and
 *	that's all for the moment).
 */

typedef struct {
	/* length */
	uint8_t n;
	/* all */
	map_ai_spawn_t __attribute__((aligned(2))) spawns[];
} __attribute__((aligned(4))) map_ai_t;

/**
 *	mapref_t:
 *	Map reference.
 *
 *	This is used for the map list.
 */

typedef struct {
	map_t *map;
	map_ai_t *ai;
} mapref_t;

#endif /* MAIN_MAP_H */
