/* ************************************************************************** */
/*                                       _____           _                    */
/*  credits.c                           |_   _|__  _   _| |__   ___ _   _     */
/*  | Project : TuQuoque                  | |/ _ \| | | | '_ \ / _ \ | | |    */
/*                                        | | (_) | |_| | | | |  __/ |_| |    */
/*  By: thomas <thomas@touhey.fr>         |_|\___/ \__,_|_| |_|\___|\__, |.fr */
/*  Last updated: 2016/08/08 18:08:58                               |___/     */
/*                                                                            */
/* ************************************************************************** */

#include <string.h>
#include <display.h>
#include <tales.h>
#include <keyboard.h>
#include <main.h>
#define font_char_w 5
#define font_char_h 7

/**
 *	display_center:
 *	Display the given text centered horizontally.
 *
 *	There is no function to get the size that a string will occupy on screen
 *	yet in gint, but we know that all the characters of gint's default font
 *	are 5*7px long.
 *
 *	@arg	s		the string
 *	@arg	y		ordinate to which display
 */

static void display_center(char *s, int y)
{
	int n = strlen(s);
	int x = (DISPLAY_WIDTH - n * font_char_w - (n - 1) * 1) / 2;
	dtext(x, y, s);
}

/**
 *	credits:
 *	Credits menu.
 *
 *	CPC rules mention that participating programs must indicate they are
 *	participating somewhere. This is the place.
 *
 *	Uses the default font to print text.
 *
 *	There is no function to get the size that a string will occupy on screen
 *	yet in gint, but we know that all the characters of gint's default font
 *	are 5*7px long.
 *
 *	@arg	last	last menu (unused, last menu is always main menu)
 */

void *credits(void *last)
{
	(void)last;

	/* all strings */
	/* (occupies a little more space than necessary, but who cares */
	char strings[5][21] = {
		"Made by Cakeisalie5",
		"for the 20th edition",
		"of Planete Casio's",
		"Casio Programming",
		"Contests."};

	/* initial display */
	dclear();
	int mid = DISPLAY_HEIGHT / 2 - font_char_h / 2;
	display_center(strings[0], mid - font_char_h * 2 - 2);
	display_center(strings[1], mid - font_char_h - 1);
	display_center(strings[2], mid);
	display_center(strings[3], mid + font_char_h + 1);
	display_center(strings[4], mid + font_char_h * 2 + 2);
	dupdate();

	/* game loop */
	int nobreak = 1;
	while (nobreak) {
		int key = getkey_opt(0, 0);
		switch (key) {
		case KEY_EXE:
		case KEY_EXIT:
			nobreak = 0;
			break;
		}
	}

	/* go back to main menu */
	return (last);
}
