/* ************************************************************************** */
/*                                       _____           _                    */
/*  main.c                              |_   _|__  _   _| |__   ___ _   _     */
/*  | Project : TuQuoque                  | |/ _ \| | | | '_ \ / _ \ | | |    */
/*                                        | | (_) | |_| | | | |  __/ |_| |    */
/*  By: thomas <thomas@touhey.fr>         |_|\___/ \__,_|_| |_|\___|\__, |.fr */
/*  Last updated: 2016/08/07 01:56:17                               |___/     */
/*                                                                            */
/* ************************************************************************** */

#include <display.h>
#include <keyboard.h>
#include <main.h>

/**
 *	main:
 *	User entry point of the program.
 *
 *	This function is the center of the the menu system.
 *	Each menu is launched with the address of the last one, and returns the
 *	address of the next one. When the next one is NULL, it means "quit".
 *
 *	A type cannot be defined recursively, which results in the void* type
 *	for parameter and return value.
 */

int main(void)
{
	/* initialize random */
	//srand(time(NULL));

	/* then let's play baby */
	menu_t menu = &main_menu, last = NULL, new = NULL;
	while (menu) {
		new = (menu_t)(*menu)(last);
		last = menu; menu = new;
	}
	return (0);
}
