/* ************************************************************************** */
/*                                       _____           _                    */
/*  main_menu.c                         |_   _|__  _   _| |__   ___ _   _     */
/*  | Project : TuQuoque                  | |/ _ \| | | | '_ \ / _ \ | | |    */
/*                                        | | (_) | |_| | | | |  __/ |_| |    */
/*  By: thomas <thomas@touhey.fr>         |_|\___/ \__,_|_| |_|\___|\__, |.fr */
/*  Last updated: 2016/08/08 15:03:00                               |___/     */
/*                                                                            */
/* ************************************************************************** */

#include <display.h>
#include <keyboard.h>
#include <main.h>
#define button_size_w 39
#define button_size_h 13
#define space_x 4 /* nope, not the rocket :D */

/**
 *	button_t:
 *	The choices.
 */

typedef enum {
	button_play,
	button_credits,
	button_quit,
	max_buttons
} button_t;

/**
 *	reverse_opt:
 *	Reverse button.
 *up.thomas.touhey.fr/tuquoque_hahem.g1a
 *	This might look ugly but it is not, it is based on experiments.
 */

static void reverse_opt(button_t button)
{
	int x = 2 + (button_size_w + space_x) * button;
	dreverse_area(x, 34, x + button_size_w - 3, 34 + button_size_h - 3);
}

/**
 *	main_menu:
 *	Main menu.
 *
 *	Here is where you choose whatcha gonna do when they come for you.
 *
 *	@arg	last	last menu
 */

void *main_menu(void *last)
{
	/* check last */
	button_t what = last == &credits ? button_credits : button_play;

	/* initial display */
	dclear();
	dimage(23, 18, &img_menu_logo);
	dimage_part(1,
		33, &img_menu_buttons, 0, 0,
		button_size_w, button_size_h);
	dimage_part(1 + (button_size_w + space_x),
		33, &img_menu_buttons, 0, (button_size_h - 1),
		button_size_w, button_size_h);
	dimage_part(1 + (button_size_w + space_x) * 2,
		33, &img_menu_buttons, 0, (button_size_h - 1) * 2,
		button_size_w, button_size_h);
	reverse_opt(what);
	dupdate();

	/* game loop */
	int nobreak = 1;
	while (nobreak) {
		int key = getkey_opt(0, 0);
		switch (key) {
		/* change currently selected option */
		case KEY_LEFT:
		case KEY_RIGHT:
			reverse_opt(what);
			what += max_buttons + (key == KEY_LEFT ? -1 : 1);
			what %= max_buttons;
			reverse_opt(what);
			dupdate();
			break;

		/* go to menu */
		case KEY_EXIT:
			what = button_quit;
		case KEY_EXE:
			nobreak = 0;
			break;
		}
	}

	/* return corresponding menu */
	return (what == button_play ? &select_level :
		what == button_credits ? &credits : NULL);
}
