#!/bin/sh
#******************************************************************************#
#                                        _____           _                     #
#   make-maps-include-file.sh           |_   _|__  _   _| |__   ___ _   _      #
#   | Project : TuQuoque                  | |/ _ \| | | | '_ \ / _ \ | | |     #
#                                         | | (_) | |_| | | | |  __/ |_| |     #
#   By: thomas <thomas@touhey.fr>         |_|\___/ \__,_|_| |_|\___|\__, |.fr  #
#   Last updated: 2016/07/26 06:25:52                               |___/      #
#                                                                              #
#******************************************************************************#
# Start file
cat <<EOF
#ifndef MAIN_MAPS_H
# define MAIN_MAPS_H
# include <main/map.h>

/* Generated by $0 */

/*
 *	All the maps with their defines.
 *	Enjoy.
 */

EOF

for i in $@; do
	i=$(echo $i | tr ./ _)
	cat <<EOF
#define map_${i} map_${i}_start
extern map_t map_${i}_start;
#define map_${i}_enemies map_${i}_enemies_start
extern map_ai_t map_${i}_enemies_start;
EOF
done

cat <<EOF

/**
 *	maplist:
 *	The map list.
 */

# define maplist_size $#
extern mapref_t maplist[];

#endif /* MAIN_MAPS_H */
EOF
