#******************************************************************************#
#                                        _____           _                     #
#   tqmap/__init__.py                   |_   _|__  _   _| |__   ___ _   _      #
#   | Project : TuQuoque/TQMap            | |/ _ \| | | | '_ \ / _ \ | | |     #
#                                         | | (_) | |_| | | | |  __/ |_| |     #
#   By: thomas <thomas@touhey.fr>         |_|\___/ \__,_|_| |_|\___|\__, |.fr  #
#   Last updated: 2016/08/10 21:09:58                               |___/      #
#                                                                              #
#******************************************************************************#
# Imports
from tqmap.tqmap import TQMap

# Create map and add surfaces
m = TQMap(air_char=' ', player_spawn_char='Y', enemy_spawn_char='E')
##
##	From now, encodings of tuples are :
##	- for straight ones : (up, right, down, left)
##	- for diagonals ones : (up-right, down-right, down-left, up-left)
##
# - Walls
m.add_tile("wall", "■", corresp = {
	# walls against walls
	(1, 1, 1, 0): 7,
	(0, 1, 1, 1): 8,
	(1, 0, 1, 1): 9,
	(1, 1, 0, 1): 6,
	# corners
	(1, 1, 0, 0): 5,
	(0, 1, 1, 0): 2,
	(0, 0, 1, 1): 3,
	(1, 0, 0, 1): 4
}, diags = {
	(1, 1, 1, 1): {
		# no free
		(1, 1, 1, 1): 1,
		# only one free
		(0, 1, 1, 1): 5,
		(1, 0, 1, 1): 2,
		(1, 1, 0, 1): 3,
		(1, 1, 1, 0): 4
	}
})
# - Columns
m.add_tile("column", "c", corresp = {
	# walls against walls
	(1, 1, 1, 0): 11,
	(0, 1, 1, 1): 10,
	(1, 0, 1, 1): 13,
	(1, 1, 0, 1): 12
})
# - Doors
m.add_tile("door", "m", corresp = {
	# against walls
	(1, 1, 1, 0): 15,
	(0, 1, 1, 1): 16,
	(1, 0, 1, 1): 17,
	(1, 1, 0, 1): 14
})
# - Double doors
m.add_tile("left double door", "u", corresp = {
	(1, 1, 0, 1): 18,
	(1, 1, 1, 0): 19,
	(0, 1, 1, 1): 20,
	(1, 0, 1, 1): 21
})
m.add_tile("right double door", "n", corresp = {
	(1, 1, 0, 1): 22,
	(1, 1, 1, 0): 23,
	(0, 1, 1, 1): 24,
	(1, 0, 1, 1): 25
})
